% Use SWI-prolog (different implementation of clause/2 pred)

%% Object level

% In the US, stores are open all the time!
stores_open(_) :- ttrue.

weekend(saturday) :- ttrue.
weekend(sunday) :- ttrue.

sunny(sunday) :- ttrue.
sunny(monday) :- ttrue.

go_to_park(X) :- sunny(X), weekend(X).
picnic(X) :- go_to_park(X), stores_open(X).
meet_friends(X) :- picnic(X).
happy_day(X) :- meet_friends(X).

%% Meta-level

% Meta interpreter without goal-stack
solve(ttrue).
solve((A, B)) :- solve(A), solve(B).
solve(P) :- clause(P, B), solve(B).

% solve(happy_day(X)).
% X = sunday ;
% ... infinite loop
% This is caused by an attempt to find another solution for comma separated predicates:
% solve((a, b)) :- clause((a, b), X), solve(X).
% X = call((a, b))
% solve(call((a, b))) :- clause(call((a, b)), X), solve(X).
% X = call((a, b))
% ...

% Meta interpreter without goal-stack and bounded
solve(ttrue, _).
solve((A, B), N) :- M is N-1, M > 0, solve(A, M), solve(B, M).
solve(P, N) :- M is N-1, M > 0, clause(P, B), solve(B, M).

